run-compose.sh 6.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218
  1. #!/bin/bash
  2. # Define color and formatting codes
  3. BOLD='\033[1m'
  4. GREEN='\033[1;32m'
  5. WHITE='\033[1;37m'
  6. RED='\033[0;31m'
  7. NC='\033[0m' # No Color
  8. # Unicode character for tick mark
  9. TICK='\u2713'
  10. # Detect GPU driver
  11. get_gpu_driver() {
  12. # Detect NVIDIA GPUs
  13. if lspci | grep -i nvidia >/dev/null; then
  14. echo "nvidia"
  15. return
  16. fi
  17. # Detect AMD GPUs (including GCN architecture check for amdgpu vs radeon)
  18. if lspci | grep -i amd >/dev/null; then
  19. # List of known GCN and later architecture cards
  20. # This is a simplified list, and in a real-world scenario, you'd want a more comprehensive one
  21. local gcn_and_later=("Radeon HD 7000" "Radeon HD 8000" "Radeon R5" "Radeon R7" "Radeon R9" "Radeon RX")
  22. # Get GPU information
  23. local gpu_info=$(lspci | grep -i 'vga.*amd')
  24. for model in "${gcn_and_later[@]}"; do
  25. if echo "$gpu_info" | grep -iq "$model"; then
  26. echo "amdgpu"
  27. return
  28. fi
  29. done
  30. # Default to radeon if no GCN or later architecture is detected
  31. echo "radeon"
  32. return
  33. fi
  34. # Detect Intel GPUs
  35. if lspci | grep -i intel >/dev/null; then
  36. echo "i915"
  37. return
  38. fi
  39. # If no known GPU is detected
  40. echo "Unknown or unsupported GPU driver"
  41. exit 1
  42. }
  43. # Function for rolling animation
  44. show_loading() {
  45. local spin='-\|/'
  46. local i=0
  47. printf " "
  48. while kill -0 $1 2>/dev/null; do
  49. i=$(( (i+1) %4 ))
  50. printf "\b${spin:$i:1}"
  51. sleep .1
  52. done
  53. # Replace the spinner with a tick
  54. printf "\b${GREEN}${TICK}${NC}"
  55. }
  56. # Usage information
  57. usage() {
  58. echo "Usage: $0 [OPTIONS]"
  59. echo "Options:"
  60. echo " --enable-gpu[count=COUNT] Enable GPU support with the specified count."
  61. echo " --enable-api[port=PORT] Enable API and expose it on the specified port."
  62. echo " --webui[port=PORT] Set the port for the web user interface."
  63. echo " --data[folder=PATH] Bind mount for ollama data folder (by default will create the 'ollama' volume)."
  64. echo " -q, --quiet Run script in headless mode."
  65. echo " -h, --help Show this help message."
  66. echo ""
  67. echo "Examples:"
  68. echo " $0 --enable-gpu[count=1]"
  69. echo " $0 --enable-api[port=11435]"
  70. echo " $0 --enable-gpu[count=1] --enable-api[port=12345] --webui[port=3000]"
  71. echo " $0 --enable-gpu[count=1] --enable-api[port=12345] --webui[port=3000] --data[folder=./ollama-data]"
  72. echo ""
  73. echo "This script configures and runs a docker-compose setup with optional GPU support, API exposure, and web UI configuration."
  74. echo "About the gpu to use, the script automatically detects it using the "lspci" command."
  75. echo "In this case the gpu detected is: $(get_gpu_driver)"
  76. }
  77. # Default values
  78. gpu_count=1
  79. api_port=11435
  80. webui_port=3000
  81. headless=false
  82. # Function to extract value from the parameter
  83. extract_value() {
  84. echo "$1" | sed -E 's/.*\[.*=(.*)\].*/\1/; t; s/.*//'
  85. }
  86. # Parse arguments
  87. while [[ $# -gt 0 ]]; do
  88. key="$1"
  89. case $key in
  90. --enable-gpu*)
  91. enable_gpu=true
  92. value=$(extract_value "$key")
  93. gpu_count=${value:-1}
  94. ;;
  95. --enable-api*)
  96. enable_api=true
  97. value=$(extract_value "$key")
  98. api_port=${value:-11435}
  99. ;;
  100. --webui*)
  101. value=$(extract_value "$key")
  102. webui_port=${value:-3000}
  103. ;;
  104. --data*)
  105. value=$(extract_value "$key")
  106. data_dir=${value:-"./ollama-data"}
  107. ;;
  108. -q|--quiet)
  109. headless=true
  110. ;;
  111. -h|--help)
  112. usage
  113. exit
  114. ;;
  115. *)
  116. # Unknown option
  117. echo "Unknown option: $key"
  118. usage
  119. exit 1
  120. ;;
  121. esac
  122. shift # past argument or value
  123. done
  124. DEFAULT_COMPOSE_COMMAND="docker compose -f docker-compose.yaml"
  125. if [[ $enable_gpu == true ]]; then
  126. # Validate and process command-line arguments
  127. if [[ -n $gpu_count ]]; then
  128. if ! [[ $gpu_count =~ ^[0-9]+$ ]]; then
  129. echo "Invalid GPU count: $gpu_count"
  130. exit 1
  131. fi
  132. echo "Enabling GPU with $gpu_count GPUs"
  133. # Add your GPU allocation logic here
  134. export OLLAMA_GPU_DRIVER=$(get_gpu_driver)
  135. export OLLAMA_GPU_COUNT=$gpu_count # Set OLLAMA_GPU_COUNT environment variable
  136. fi
  137. DEFAULT_COMPOSE_COMMAND+=" -f docker-compose.gpu.yaml"
  138. fi
  139. if [[ $enable_api == true ]]; then
  140. DEFAULT_COMPOSE_COMMAND+=" -f docker-compose.api.yaml"
  141. if [[ -n $api_port ]]; then
  142. export OLLAMA_WEBAPI_PORT=$api_port # Set OLLAMA_WEBAPI_PORT environment variable
  143. fi
  144. fi
  145. if [[ -n $data_dir ]]; then
  146. DEFAULT_COMPOSE_COMMAND+=" -f docker-compose.data.yaml"
  147. export OLLAMA_DATA_DIR=$data_dir # Set OLLAMA_DATA_DIR environment variable
  148. fi
  149. DEFAULT_COMPOSE_COMMAND+=" up -d > /dev/null 2>&1"
  150. # Recap of environment variables
  151. echo
  152. echo -e "${WHITE}${BOLD}Current Setup:${NC}"
  153. echo -e " ${GREEN}${BOLD}GPU Driver:${NC} ${OLLAMA_GPU_DRIVER:-Not Enabled}"
  154. echo -e " ${GREEN}${BOLD}GPU Count:${NC} ${OLLAMA_GPU_COUNT:-Not Enabled}"
  155. echo -e " ${GREEN}${BOLD}WebAPI Port:${NC} ${OLLAMA_WEBAPI_PORT:-Not Enabled}"
  156. echo -e " ${GREEN}${BOLD}Data Folder:${NC} ${data_dir:-Using ollama volume}"
  157. echo -e " ${GREEN}${BOLD}WebUI Port:${NC} $webui_port"
  158. echo
  159. if [[ $headless == true ]]; then
  160. echo -ne "${WHITE}${BOLD}Running in headless mode... ${NC}"
  161. choice="y"
  162. else
  163. # Ask for user acceptance
  164. echo -ne "${WHITE}${BOLD}Do you want to proceed with current setup? (Y/n): ${NC}"
  165. read -n1 -s choice
  166. fi
  167. echo -e " ${GREEN}${BOLD}WebUI Port:${NC} $webui_port"
  168. echo
  169. # Ask for user acceptance
  170. echo -ne "${WHITE}${BOLD}Do you want to proceed with current setup? (Y/n): ${NC}"
  171. read -n1 -s choice
  172. if [[ $choice == "" || $choice == "y" ]]; then
  173. # Execute the command with the current user
  174. eval "docker compose down > /dev/null 2>&1; $DEFAULT_COMPOSE_COMMAND" &
  175. # Capture the background process PID
  176. PID=$!
  177. # Display the loading animation
  178. show_loading $PID
  179. # Wait for the command to finish
  180. wait $PID
  181. echo
  182. # Check exit status
  183. if [ $? -eq 0 ]; then
  184. echo -e "${GREEN}${BOLD}Compose project started successfully.${NC}"
  185. else
  186. echo -e "${RED}${BOLD}There was an error starting the compose project.${NC}"
  187. fi
  188. else
  189. echo "Aborted."
  190. fi
  191. echo